#include <bits/stdc++.h>
#define ll long long

using namespace std;

ll gcd (ll a, ll b) {
    return b ? gcd (b, a % b) : a;
}
bool xExists(){

    int n,m;
    cin>>n>>m;
    vector<ll> a(n);
    vector<ll> b(m);

    for(int i=0;i<n;i++) cin>>a[i];

    for(int i=0;i<m;i++) cin>>b[i];

    int g=abs(a[0]-a[1]);

    for(int i=2;i<n;i++)
        g=gcd(abs(a[i]-a[i-1]),g);

    for(int i=0;i<m;i++)
        if(abs(a[0]-b[i])%g==0)return false;

    return true;
}


int main()
{
    int t;
    cin>>t;
    for(int k=0;k<t;k++){
        cout << xExists() << endl;
    }

    return 0;
}